﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_msgs:msg/HeadingValue.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_MSGS__MSG__DETAIL__HEADING_VALUE__STRUCT_H_
#define ETSI_ITS_CAM_MSGS__MSG__DETAIL__HEADING_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_msgs__msg__HeadingValue__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_msgs__msg__HeadingValue__MAX = 3601
};

/// Constant 'WGS84_NORTH'.
enum
{
  etsi_its_cam_msgs__msg__HeadingValue__WGS84_NORTH = 0
};

/// Constant 'WGS84_EAST'.
enum
{
  etsi_its_cam_msgs__msg__HeadingValue__WGS84_EAST = 900
};

/// Constant 'WGS84_SOUTH'.
enum
{
  etsi_its_cam_msgs__msg__HeadingValue__WGS84_SOUTH = 1800
};

/// Constant 'WGS84_WEST'.
enum
{
  etsi_its_cam_msgs__msg__HeadingValue__WGS84_WEST = 2700
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_msgs__msg__HeadingValue__UNAVAILABLE = 3601
};

/// Struct defined in msg/HeadingValue in the package etsi_its_cam_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_msgs__msg__HeadingValue
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// HeadingValue ::= INTEGER {wgs84North(0), wgs84East(900), wgs84South(1800), wgs84West(2700), unavailable(3601)} (0..3601)
  /// ------------------------------------------------------------------------------
  uint16_t value;
} etsi_its_cam_msgs__msg__HeadingValue;

// Struct for a sequence of etsi_its_cam_msgs__msg__HeadingValue.
typedef struct etsi_its_cam_msgs__msg__HeadingValue__Sequence
{
  etsi_its_cam_msgs__msg__HeadingValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_msgs__msg__HeadingValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_MSGS__MSG__DETAIL__HEADING_VALUE__STRUCT_H_
