﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_msgs:msg/StationType.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_MSGS__MSG__DETAIL__STATION_TYPE__STRUCT_H_
#define ETSI_ITS_CAM_MSGS__MSG__DETAIL__STATION_TYPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_msgs__msg__StationType__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_msgs__msg__StationType__MAX = 255
};

/// Constant 'UNKNOWN'.
enum
{
  etsi_its_cam_msgs__msg__StationType__UNKNOWN = 0
};

/// Constant 'PEDESTRIAN'.
enum
{
  etsi_its_cam_msgs__msg__StationType__PEDESTRIAN = 1
};

/// Constant 'CYCLIST'.
enum
{
  etsi_its_cam_msgs__msg__StationType__CYCLIST = 2
};

/// Constant 'MOPED'.
enum
{
  etsi_its_cam_msgs__msg__StationType__MOPED = 3
};

/// Constant 'MOTORCYCLE'.
enum
{
  etsi_its_cam_msgs__msg__StationType__MOTORCYCLE = 4
};

/// Constant 'PASSENGER_CAR'.
enum
{
  etsi_its_cam_msgs__msg__StationType__PASSENGER_CAR = 5
};

/// Constant 'BUS'.
enum
{
  etsi_its_cam_msgs__msg__StationType__BUS = 6
};

/// Constant 'LIGHT_TRUCK'.
enum
{
  etsi_its_cam_msgs__msg__StationType__LIGHT_TRUCK = 7
};

/// Constant 'HEAVY_TRUCK'.
enum
{
  etsi_its_cam_msgs__msg__StationType__HEAVY_TRUCK = 8
};

/// Constant 'TRAILER'.
enum
{
  etsi_its_cam_msgs__msg__StationType__TRAILER = 9
};

/// Constant 'SPECIAL_VEHICLES'.
enum
{
  etsi_its_cam_msgs__msg__StationType__SPECIAL_VEHICLES = 10
};

/// Constant 'TRAM'.
enum
{
  etsi_its_cam_msgs__msg__StationType__TRAM = 11
};

/// Constant 'ROAD_SIDE_UNIT'.
enum
{
  etsi_its_cam_msgs__msg__StationType__ROAD_SIDE_UNIT = 15
};

/// Struct defined in msg/StationType in the package etsi_its_cam_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_msgs__msg__StationType
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// StationType ::= INTEGER {unknown(0), pedestrian(1), cyclist(2), moped(3), motorcycle(4), passengerCar(5), bus(6),
  /// lightTruck(7), heavyTruck(8), trailer(9), specialVehicles(10), tram(11), roadSideUnit(15)} (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_msgs__msg__StationType;

// Struct for a sequence of etsi_its_cam_msgs__msg__StationType.
typedef struct etsi_its_cam_msgs__msg__StationType__Sequence
{
  etsi_its_cam_msgs__msg__StationType * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_msgs__msg__StationType__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_MSGS__MSG__DETAIL__STATION_TYPE__STRUCT_H_
