// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_msgs:msg/VehicleIdentification.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_MSGS__MSG__DETAIL__VEHICLE_IDENTIFICATION__TRAITS_HPP_
#define ETSI_ITS_CAM_MSGS__MSG__DETAIL__VEHICLE_IDENTIFICATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_msgs/msg/detail/vehicle_identification__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'w_m_inumber'
#include "etsi_its_cam_msgs/msg/detail/wm_inumber__traits.hpp"
// Member 'v_ds'
#include "etsi_its_cam_msgs/msg/detail/vds__traits.hpp"

namespace etsi_its_cam_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const VehicleIdentification & msg,
  std::ostream & out)
{
  out << "{";
  // member: w_m_inumber
  {
    out << "w_m_inumber: ";
    to_flow_style_yaml(msg.w_m_inumber, out);
    out << ", ";
  }

  // member: w_m_inumber_is_present
  {
    out << "w_m_inumber_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.w_m_inumber_is_present, out);
    out << ", ";
  }

  // member: v_ds
  {
    out << "v_ds: ";
    to_flow_style_yaml(msg.v_ds, out);
    out << ", ";
  }

  // member: v_ds_is_present
  {
    out << "v_ds_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.v_ds_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VehicleIdentification & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: w_m_inumber
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "w_m_inumber:\n";
    to_block_style_yaml(msg.w_m_inumber, out, indentation + 2);
  }

  // member: w_m_inumber_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "w_m_inumber_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.w_m_inumber_is_present, out);
    out << "\n";
  }

  // member: v_ds
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "v_ds:\n";
    to_block_style_yaml(msg.v_ds, out, indentation + 2);
  }

  // member: v_ds_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "v_ds_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.v_ds_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VehicleIdentification & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_msgs::msg::VehicleIdentification & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_msgs::msg::VehicleIdentification & msg)
{
  return etsi_its_cam_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_msgs::msg::VehicleIdentification>()
{
  return "etsi_its_cam_msgs::msg::VehicleIdentification";
}

template<>
inline const char * name<etsi_its_cam_msgs::msg::VehicleIdentification>()
{
  return "etsi_its_cam_msgs/msg/VehicleIdentification";
}

template<>
struct has_fixed_size<etsi_its_cam_msgs::msg::VehicleIdentification>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_msgs::msg::VDS>::value && has_fixed_size<etsi_its_cam_msgs::msg::WMInumber>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_msgs::msg::VehicleIdentification>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_msgs::msg::VDS>::value && has_bounded_size<etsi_its_cam_msgs::msg::WMInumber>::value> {};

template<>
struct is_message<etsi_its_cam_msgs::msg::VehicleIdentification>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_MSGS__MSG__DETAIL__VEHICLE_IDENTIFICATION__TRAITS_HPP_
