// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_msgs:msg/VehicleIdentification.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_MSGS__MSG__DETAIL__VEHICLE_IDENTIFICATION__STRUCT_HPP_
#define ETSI_ITS_CAM_MSGS__MSG__DETAIL__VEHICLE_IDENTIFICATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'w_m_inumber'
#include "etsi_its_cam_msgs/msg/detail/wm_inumber__struct.hpp"
// Member 'v_ds'
#include "etsi_its_cam_msgs/msg/detail/vds__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_msgs__msg__VehicleIdentification __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_msgs__msg__VehicleIdentification __declspec(deprecated)
#endif

namespace etsi_its_cam_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VehicleIdentification_
{
  using Type = VehicleIdentification_<ContainerAllocator>;

  explicit VehicleIdentification_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : w_m_inumber(_init),
    v_ds(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->w_m_inumber_is_present = false;
      this->v_ds_is_present = false;
    }
  }

  explicit VehicleIdentification_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : w_m_inumber(_alloc, _init),
    v_ds(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->w_m_inumber_is_present = false;
      this->v_ds_is_present = false;
    }
  }

  // field types and members
  using _w_m_inumber_type =
    etsi_its_cam_msgs::msg::WMInumber_<ContainerAllocator>;
  _w_m_inumber_type w_m_inumber;
  using _w_m_inumber_is_present_type =
    bool;
  _w_m_inumber_is_present_type w_m_inumber_is_present;
  using _v_ds_type =
    etsi_its_cam_msgs::msg::VDS_<ContainerAllocator>;
  _v_ds_type v_ds;
  using _v_ds_is_present_type =
    bool;
  _v_ds_is_present_type v_ds_is_present;

  // setters for named parameter idiom
  Type & set__w_m_inumber(
    const etsi_its_cam_msgs::msg::WMInumber_<ContainerAllocator> & _arg)
  {
    this->w_m_inumber = _arg;
    return *this;
  }
  Type & set__w_m_inumber_is_present(
    const bool & _arg)
  {
    this->w_m_inumber_is_present = _arg;
    return *this;
  }
  Type & set__v_ds(
    const etsi_its_cam_msgs::msg::VDS_<ContainerAllocator> & _arg)
  {
    this->v_ds = _arg;
    return *this;
  }
  Type & set__v_ds_is_present(
    const bool & _arg)
  {
    this->v_ds_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_msgs::msg::VehicleIdentification_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_msgs::msg::VehicleIdentification_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_msgs::msg::VehicleIdentification_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_msgs::msg::VehicleIdentification_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_msgs::msg::VehicleIdentification_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_msgs::msg::VehicleIdentification_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_msgs::msg::VehicleIdentification_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_msgs::msg::VehicleIdentification_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_msgs::msg::VehicleIdentification_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_msgs::msg::VehicleIdentification_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_msgs__msg__VehicleIdentification
    std::shared_ptr<etsi_its_cam_msgs::msg::VehicleIdentification_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_msgs__msg__VehicleIdentification
    std::shared_ptr<etsi_its_cam_msgs::msg::VehicleIdentification_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VehicleIdentification_ & other) const
  {
    if (this->w_m_inumber != other.w_m_inumber) {
      return false;
    }
    if (this->w_m_inumber_is_present != other.w_m_inumber_is_present) {
      return false;
    }
    if (this->v_ds != other.v_ds) {
      return false;
    }
    if (this->v_ds_is_present != other.v_ds_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const VehicleIdentification_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VehicleIdentification_

// alias to use template instance with default allocator
using VehicleIdentification =
  etsi_its_cam_msgs::msg::VehicleIdentification_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_msgs

#endif  // ETSI_ITS_CAM_MSGS__MSG__DETAIL__VEHICLE_IDENTIFICATION__STRUCT_HPP_
